program inst_tc_plugins;

uses
  Windows,
  Registry,
  SysUtils,
  KOL,
  IniFiles;

{$R *.res}
var
  h: hwnd;
  PluginNotFound: widestring = '   .';
  NotPlugin: widestring = '  .';
  EnterExtFileName: widestring = ' ,    :';
  neededReboot: widestring = '  Total Commander.';
  SetupListerOk: widestring = ' Lister-  .';
  SetupFSOk: widestring = ' FS-  .';
  SetupArcOk: widestring = '    .';
  PluginExist: widestring = '     .'+chr(13)+chr(10)+
                '  ?';
  PluginNotSetup: widestring = '   .';
  FileExtIsNull: widestring = '    .';
  SymbolErr1: widestring = '  "';
  SymbolErr2: widestring = '"     .';
  ExtUse: widestring = '       .'+chr(13)+chr(10)+'   ?';
  WFXQuestion: widestring = '   *.wfx '+chr(13)+chr(10)+'  ?';
  WLXQuestion: widestring = '   *.wlx '+chr(13)+chr(10)+'  ?';
  WCXQuestion: widestring = '   *.wcx '+chr(13)+chr(10)+'  ?';
  IniFileNotFound1: widestring = ' ';
  IniFileNotFound2: widestring = '  .'+chr(13)+chr(10)+'  Total Commander         .';
  WFXDescription: widestring = 'FS-  Total Commander';
  WLXDescription: widestring = 'Lister-  Total Commander';
  WCXDescription: widestring = '   Total Commander';
  FileNotMZ: widestring = '    ,  .';

  txtOk: widestring = '';
  txtCancel: widestring = '';

const
  ProgName: widestring = 'Install TC plugins';

type
  TFsGetDefRootName = procedure (DefRootName:pchar;maxlen:integer); stdcall;

var
  inifile : IniFiles.TIniFile;
  reg : TRegistry;
  Handle: THAndle;
  FsGetDefRootName: TFsGetDefRootName;
  PluginFileName, IniPath : string;
  LangStr, LangMsgN, LangMsgVal : widestring;
//   KOL
  form, editbox, butok, butcancel:PControl;
  text : PChar;
  F: textfile;
  byte1: char;
  byte2: char;
  exten, i: integer;

//    KOL
procedure ClickOK( Dummy : Pointer; Sender: PControl );
begin
  text:=PChar(editbox.text);
  form.Close;
end;

procedure ClickCANCEL( Dummy : Pointer; Sender: PControl );
begin
  text:='CANCEL BUTTON';
  form.Close;
end;

procedure KeyPRESS( Dummy : Pointer; Sender: PControl; var Key: Longint; Shift: DWORD );
begin
  case Key of
    13: begin
        text:=PChar(editbox.text);
        form.Close;
        end;
    27: begin
        text:='CANCEL BUTTON';
        form.Close;
        end;
  end;
end;

function EnterFileExt (): string;
begin
  form:=NewForm(Applet,PChar(ProgName)).CenterOnParent.Shift(-100,-20);
  form.Style := WS_THICKFRAME or WS_VISIBLE or WS_POPUP or WS_CAPTION;
  form.Font.FontHeight:=8;
  form.Font.FontName:=DefFont.Name;
  NewLabel(form, EnterExtFileName).AutoSize(true);
  editbox:=NewEditbox(form, [eoWantTab]).Shift(0,18).Size(110,22);
  editbox.Color:= clWindow;
  editbox.OnKeyDown := TOnKey(MakeMethod(nil,@KeyPRESS));
  editbox.TabOrder:=0;
  butok:=NewButton(form, PChar(txtOk)).Shift(122,18).Size(80,22);
  butok.OnClick := TOnEvent(MakeMethod(nil,@ClickOK));
  butok.TabOrder:=1;
  butcancel:=NewButton(form, PChar(txtCancel)).Shift(212,18).Size(80,22);
  butcancel.OnClick := TOnEvent(MakeMethod(nil,@ClickCANCEL));
  butcancel.TabOrder:=2;
  run(form);
  Result:=text;
end;
//    KOL

procedure InstallWFX(WFXName : string);
var
  nameplugin : string [255];
begin
Handle := LoadLibrary(PChar(WFXName));
if Handle > 0 then
  begin
    @FsGetDefRootName:=GetProcAddress(Handle, 'FsGetDefRootName');
    if @FsGetDefRootName<>nil then
      begin
        FsGetDefRootName(@nameplugin[1],254);
        nameplugin[0] := chr(254);
      end
    else
      begin
        nameplugin:=copy(ExtractFileName(WFXName),1,Length(ExtractFileName(WFXName))-Length(ExtractFileExt(WFXName)));
        //MessageBox(0,PChar(FSPluginNameNotFound),Pchar(ProgName),MB_OK+MB_ICONERROR);
      end;
    inifile.WriteString('FileSystemPlugins',nameplugin, WFXName);
    MessageBoxW(0,PWideChar(SetupFSOk+chr(13)+chr(10)+neededReboot),PWideChar(ProgName),MB_OK+MB_ICONINFORMATION);
    FreeLibrary(Handle);
  end
else
  begin
    //       DLL
    MessageBoxW(0,PWideChar(FileNotMZ),PWideChar(ProgName),MB_OK+MB_ICONERROR);
  end;
end;

procedure InstallWLX(WLXName : string);
var i : integer;
var WLX : string;
label inst;
begin
  WLX:=ExtractFileName(WLXName);
  i:=0;
  while inifile.ReadString('ListerPlugins',IntToStr(i),'!err')<>'!err' do
    begin
      if LowerCase(ExtractFileName(inifile.ReadString('ListerPlugins',IntToStr(i),'')))=LowerCase(WLX) then
        begin
          if MessageBoxW(0,PWideChar(PluginExist),PWideChar(ProgName),MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2)=7 then
            begin
              MessageBoxW(0,PWideChar(PluginNotSetup),PWideChar(ProgName),MB_OK+MB_ICONERROR);
              exit
            end
          else
            goto inst;
        end;
      i:=i+1;
    end;
inst:
  inifile.WriteString('ListerPlugins', IntToStr(i), WLXName);
  MessageBoxW(0,PWideChar(SetupListerOK+chr(13)+chr(10)+neededReboot),PWideChar(ProgName),MB_OK+MB_ICONINFORMATION);
end;

procedure InstallWCX(WCXName : string);
var ext : string;
  i:integer;
label _repeat;
begin
 // WCX
  ext:='';
_repeat:
  ext:=EnterFileExt;
  if ext='CANCEL BUTTON' then
    begin
      MessageBoxW(0,PWideChar(PluginNotSetup),PWideChar(ProgName),MB_OK+MB_ICONERROR);
      exit;
    end;
  if ext='' then
    begin
      MessageBoxW(0,PWideChar(FileExtIsNull),PWideChar(ProgName),MB_OK+MB_ICONERROR);
      exit;
    end;
  for i:=1 to length(ext) do
    begin
      case ord(ext[i]) of
      33,35..41,45,48..57,62..90,94..95,97..122,126,192..255: begin end;
      else
        begin
          MessageBoxW(0,PWideChar(SymbolErr1+ext[i]+SymbolErr2),PWideChar(ProgName),MB_OK+MB_ICONERROR);
          goto _repeat;
        end;
      end;
    end;
  if ExtractFileName(inifile.ReadString('PackerPlugins',ext,''))<>'' then
    begin
      if MessageBoxW(0,PWideChar(ExtUse),PWideChar(ProgName),MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2)=7 then exit;
    end;
  inifile.WriteString('PackerPlugins', ext, WCXName);
  MessageBoxW(0,PWideChar(SetupArcOk+chr(13)+chr(10)+neededReboot),PWideChar(ProgName),MB_OK+MB_ICONINFORMATION);
end;

procedure RegisterFileExt(ProgFile, Ext, Name, Description, IconNum : string);
var reg : TRegistry;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_CLASSES_ROOT;
    if reg.OpenKey('\.'+Ext,True) then
      begin
        reg.WriteString('',Name);
        reg.CloseKey;
      end;
    if reg.OpenKey('\'+Name,True) then
      begin
        reg.WriteString('',Description);
        reg.CloseKey;
      end;
    if reg.OpenKey('\'+Name+'\shell\Open\command',True) then
      begin
        reg.WriteString('','"'+ProgFile+'" "%1"');
        reg.CloseKey;
      end;
    if reg.OpenKey('\'+Name+'\DefaultIcon',True) then
      begin
        reg.WriteString('','"'+ProgFile+'",'+IconNum);
        reg.CloseKey;
      end;
  finally
  reg.Free;
  end;
end;

begin
  if FileExists(ExtractFilePath(ParamStr(0))+'inst_tc_plugins.lng') then
  begin
    AssignFile(F,ExtractFilePath(ParamStr(0))+'inst_tc_plugins.lng');
    try
    FileMode:=0;
    Reset(F);
    while not Eof(F) do
    begin
      Readln(F, LangStr);
      if Pos('=',LangStr)<>0 then
      begin
        LangMsgN:=copy(LangStr,1,Pos('=',LangStr)-1);
        LangMsgVal:=copy(LangStr,Pos('=',LangStr)+1,Length(LangStr)-Pos('=',LangStr));
        if Pos('\n',LangMsgVal)>0 then LangMsgVal:=copy(LangMsgVal,1,Pos('\n',LangMsgVal)-1)+chr(13)+chr(10)+copy(LangMsgVal,Pos('\n',LangMsgVal)+2,Length(LangMsgVal)-Pos('\n',LangMsgVal)-1);
        try
          i:=StrToInt(LangMsgN);
        except
          i:=0;
        end;
        case i of
        1: PluginNotFound:=LangMsgVal;
        2: NotPlugin:=LangMsgVal;
        3: EnterExtFileName:=LangMsgVal;
        4: neededReboot:=LangMsgVal;
        5: SetupListerOk:=LangMsgVal;
        6: SetupFSOk:=LangMsgVal;
        7: SetupArcOk:=LangMsgVal;
        8: PluginExist:=LangMsgVal;
        9: PluginNotSetup:=LangMsgVal;
        10: FileExtIsNull:=LangMsgVal;
        11: SymbolErr1:=LangMsgVal;
        12: SymbolErr2:=LangMsgVal;
        13: ExtUse:=LangMsgVal;
        14: WFXQuestion:=LangMsgVal;
        15: WLXQuestion:=LangMsgVal;
        16: WCXQuestion:=LangMsgVal;
        17: IniFileNotFound1:=LangMsgVal;
        18: IniFileNotFound2:=LangMsgVal;
        19: WFXDescription:=LangMsgVal;
        20: WLXDescription:=LangMsgVal;
        21: WCXDescription:=LangMsgVal;
        22: FileNotMZ:=LangMsgVal;
        23: txtOk:=LangMsgVal;
        24: txtCancel:=LangMsgVal;
        end;//case
      end;
    end;//while
    finally
    CloseFile(F);
    end;
  end;
  PluginFileName:='';
  for i := 1 to ParamCount do
  begin
    if ParamStr(i)[1]<>'/' then
      begin
        PluginFileName:=ExpandFileName(ParamStr(i));
        break;
      end;
  end;
  if PluginFileName='' then
    begin
      if MessageBoxW(h,PWideChar(WFXQuestion),PWideChar(ProgName),MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2)=6 then
        RegisterFileExt(ParamStr(0),'wfx','WFX-plugin',WFXDescription,'1');
      if MessageBoxW(h,PWideChar(WLXQuestion),PWideChar(ProgName),MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2)=6 then
        RegisterFileExt(ParamStr(0),'wlx','WLX-plugin',WLXDescription,'2');
      if MessageBoxW(h,PWideChar(WCXQuestion),PWideChar(ProgName),MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2)=6 then
        RegisterFileExt(ParamStr(0),'wcx','WCX-plugin',WCXDescription,'3');
      exit;
    end;
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_CURRENT_USER;
    If reg.OpenKey('\Software\Ghisler\Total Commander\',False) then
      IniPath:=reg.ReadString('IniFileName')
    else
      begin
        reg.RootKey := HKEY_LOCAL_MACHINE;
        If reg.OpenKey('\Software\Ghisler\Total Commander\',False) then
          IniPath:=reg.ReadString('IniFileName')
        else
          IniPath:=GetWindowsDir+'wincmd.ini';
      //  MessageBox(0,PChar(IniPathNotFound),Pchar(ProgName),MB_OK+MB_ICONERROR);
      //  exit;
      end;
    If IniPath[1]='.' then
      IniPath:=reg.ReadString('InstallDir')+copy(IniPath,2,Length(IniPath)-1);
  finally
  reg.Free;
  end;
  if copy(IniPath,1,13)='%USERPROFILE%' then
  begin
    IniPath:=GetEnvironmentVariable('USERPROFILE')+copy(IniPath,14,Length(IniPath)-13);
  end;

  if FileExists(IniPath)=false then
    begin
      MessageBoxW(0,PWideChar(IniFileNotFound1+IniPath+IniFileNotFound2),PWideChar(ProgName),MB_OK+MB_ICONERROR);
      exit;
    end;
  if FileExists(PluginFileName)=false then
    begin
      MessageBoxW(0,PWideChar(PluginNotFound),PWideChar(ProgName),MB_OK+MB_ICONERROR);
      exit;
    end;
  AssignFile(F,PluginFileName);
  FileMode:=0;
  Reset(F);
  Read(F, byte1, byte2);
  CloseFile(F);
  if (byte1<>'M') or (byte2<>'Z') then
  begin
    MessageBoxW(0,PWideChar(FileNotMZ),PWideChar(ProgName),MB_OK+MB_ICONERROR);
    exit;
  end;
  inifile:=TIniFile.Create(IniPath);
  try
  exten:=0;
  for i := 1 to ParamCount do
  begin
    if LowerCase(ParamStr(i))='/wfx' then exten:=1;
    if LowerCase(ParamStr(i))='/wlx' then exten:=2;
    if LowerCase(ParamStr(i))='/wcx' then exten:=3;
  end;
  case exten of
  1: InstallWFX(PluginFileName);
  2: InstallWLX(PluginFileName);
  3: InstallWCX(PluginFileName);
  else
    if LowerCase(ExtractFileExt(PluginFileName))='.wfx' then
      InstallWFX(PluginFileName)
    else if LowerCase(ExtractFileExt(PluginFileName))='.wlx' then
      InstallWLX(PluginFileName)
    else if LowerCase(ExtractFileExt(PluginFileName))='.wcx' then
      InstallWCX(PluginFileName)
    else MessageBoxW(0,PWideChar(NotPlugin),PWideChar(ProgName),MB_OK+MB_ICONERROR);
  end;
  finally
  inifile.Free;
  end;

end.


